ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.8 by greg, Sat Jan 29 16:44:01 2011 UTC vs.
Revision 2.37 by greg, Thu Jun 14 22:42:21 2012 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-dim xmin xmax ymin ymax zmin zmax][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12          exit 1;
13   }
14 < my $td = `mktemp -d /tmp/genBSDF.XXXXXX`;
14 > my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15   chomp $td;
16 < my $nsamp = 1000;
16 > my @savedARGV = @ARGV;
17 > my $tensortree = 0;
18 > my $ttlog2 = 4;
19 > my $nsamp = 2000;
20 > my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21   my $mgfin = 0;
22   my $geout = 1;
23   my $nproc = 1;
24 + my $doforw = 0;
25 + my $doback = 1;
26 + my $pctcull = 90;
27 + my $gunit = "Meter";
28   my @dim;
29   # Get options
30   while ($#ARGV >= 0) {
31          if ("$ARGV[0]" =~ /^[-+]m/) {
32                  $mgfin = ("$ARGV[0]" =~ /^\+/);
33 +        } elsif ("$ARGV[0]" eq "-r") {
34 +                $rtargs = "$rtargs $ARGV[1]";
35 +                shift @ARGV;
36          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
37                  $geout = ("$ARGV[0]" =~ /^\+/);
38 +                $gunit = $ARGV[1];
39 +                if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
40 +                        die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
41 +                }
42 +                shift @ARGV;
43 +        } elsif ("$ARGV[0]" =~ /^[-+]f/) {
44 +                $doforw = ("$ARGV[0]" =~ /^\+/);
45 +        } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46 +                $doback = ("$ARGV[0]" =~ /^\+/);
47 +        } elsif ("$ARGV[0]" eq "-t") {
48 +                # Use value < 0 for rttree_reduce bypass
49 +                $pctcull = $ARGV[1];
50 +                shift @ARGV;
51 +        } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52 +                $tensortree = substr($ARGV[0], 2, 1);
53 +                $ttlog2 = $ARGV[1];
54 +                shift @ARGV;
55          } elsif ("$ARGV[0]" eq "-c") {
56                  $nsamp = $ARGV[1];
57                  shift @ARGV;
# Line 40 | Line 69 | while ($#ARGV >= 0) {
69          }
70          shift @ARGV;
71   }
72 + # Check that we're actually being asked to do something
73 + die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
74   # Get scene description and dimensions
75   my $radscn = "$td/device.rad";
76   my $mgfscn = "$td/device.mgf";
# Line 49 | Line 80 | if ( $mgfin ) {
80          die "Could not load MGF input\n" if ( $? );
81          system "mgf2rad $mgfscn > $radscn";
82   } else {
83 <        system "cat @ARGV | xform -e > $radscn";
83 >        system "xform -e @ARGV > $radscn";
84          die "Could not load Radiance input\n" if ( $? );
85          system "rad2mgf $radscn > $mgfscn" if ( $geout );
86   }
# Line 57 | Line 88 | if ($#dim != 5) {
88          @dim = split ' ', `getbbox -h $radscn`;
89   }
90   print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
91 < # Add receiver surface (rectangle)
92 < my $modnm="_receiver_black_";
91 > # Add receiver surfaces (rectangular)
92 > my $fmodnm="receiver_face";
93 > my $bmodnm="receiver_behind";
94   open(RADSCN, ">> $radscn");
95 < print RADSCN "void glow $modnm\n0\n0\n4 0 0 0 0\n\n";
96 < print RADSCN "$modnm polygon _receiver_\n0\n0\n12\n";
97 < print RADSCN "\t",$dim[0],"\t",$dim[2],"\t",$dim[5]+1e-5,"\n";
98 < print RADSCN "\t",$dim[0],"\t",$dim[3],"\t",$dim[5]+1e-5,"\n";
67 < print RADSCN "\t",$dim[1],"\t",$dim[3],"\t",$dim[5]+1e-5,"\n";
68 < print RADSCN "\t",$dim[1],"\t",$dim[2],"\t",$dim[5]+1e-5,"\n";
95 > print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
96 > print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
97 > print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
98 > print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
99   close RADSCN;
100   # Generate octree
101   system "oconv -w $radscn > $octree";
102   die "Could not compile scene\n" if ( $? );
103 < # Set up sampling
103 > # Output XML prologue
104 > print
105 > '<?xml version="1.0" encoding="UTF-8"?>
106 > <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
107 > ';
108 > print "<!-- File produced by: genBSDF @savedARGV -->\n";
109 > print
110 > '<WindowElementType>System</WindowElementType>
111 > <Optical>
112 > <Layer>
113 >        <Material>
114 >                <Name>Name</Name>
115 >                <Manufacturer>Manufacturer</Manufacturer>
116 > ';
117 > printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
118 > printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
119 > printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
120 > print "\t\t<DeviceType>Integral</DeviceType>\n";
121 > # Output MGF description if requested
122 > if ( $geout ) {
123 >        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
124 >        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
125 >        open(MGFSCN, "< $mgfscn");
126 >        while (<MGFSCN>) { print $_; }
127 >        close MGFSCN;
128 >        print "xf\n";
129 >        print "\t\t</Geometry>\n";
130 > }
131 > print " </Material>\n";
132 > # Set up surface sampling
133 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
134 > my $ny = int($nsamp/$nx + .5);
135 > $nsamp = $nx * $ny;
136 > my $ns = 2**$ttlog2;
137 > my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
138 > # Create data segments (all the work happens here)
139 > if ( $tensortree ) {
140 >        do_tree_bsdf();
141 > } else {
142 >        do_matrix_bsdf();
143 > }
144 > # Output XML epilogue
145 > print
146 > '</Layer>
147 > </Optical>
148 > </WindowElement>
149 > ';
150 > # Clean up temporary files and exit
151 > exec("rm -rf $td");
152 >
153 > #-------------- End of main program segment --------------#
154 >
155 > #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
156 > sub do_tree_bsdf {
157 > # Shirley-Chiu mapping from unit square to disk
158 > $sq2disk = '
159 > in_square_a = 2*in_square_x - 1;
160 > in_square_b = 2*in_square_y - 1;
161 > in_square_rgn = if(in_square_a + in_square_b,
162 >                        if(in_square_a - in_square_b, 1, 2),
163 >                        if(in_square_b - in_square_a, 3, 4));
164 > out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
165 >                        -in_square_a, -in_square_b);
166 > out_disk_phi = PI/4 * select(in_square_rgn,
167 >                                in_square_b/in_square_a,
168 >                                2 - in_square_a/in_square_b,
169 >                                4 + in_square_b/in_square_a,
170 >                                if(in_square_b*in_square_b,
171 >                                        6 - in_square_a/in_square_b, 0));
172 > Dx = out_disk_r*cos(out_disk_phi);
173 > Dy = out_disk_r*sin(out_disk_phi);
174 > Dz = sqrt(1 - out_disk_r*out_disk_r);
175 > ';
176 > # Shirley-Chiu mapping from unit disk to square
177 > $disk2sq = '
178 > norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
179 > in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
180 > in_disk_phi = norm_radians(atan2(Dy, Dx));
181 > in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
182 > out_square_a = select(in_disk_rgn,
183 >                        in_disk_r,
184 >                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
185 >                        -in_disk_r,
186 >                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
187 > out_square_b = select(in_disk_rgn,
188 >                        in_disk_phi*in_disk_r/(PI/4),
189 >                        in_disk_r,
190 >                        (PI - in_disk_phi)*in_disk_r/(PI/4),
191 >                        -in_disk_r);
192 > out_square_x = (out_square_a + 1)/2;
193 > out_square_y = (out_square_b + 1)/2;
194 > ';
195 > # Announce ourselves in XML output
196 > print "\t<DataDefinition>\n";
197 > print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
198 > print "\t</DataDefinition>\n";
199 >
200 > # Start rcontrib processes for compute each side
201 > do_tree_rtcontrib(0) if ( $doback );
202 > do_tree_rtcontrib(1) if ( $doforw );
203 >
204 > }       # end of sub do_tree_bsdf()
205 >
206 > # Run rcontrib process in background to generate tensor tree samples
207 > sub do_tree_rtcontrib {
208 >        my $forw = shift;
209 >        my $matargs = "-m $bmodnm";
210 >        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
211 >        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
212 >                "-e '$disk2sq' -bn '$ns*$ns' " .
213 >                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
214 >                "-o $td/%s.flt $matargs $octree";
215 >        if ( $tensortree == 3 ) {
216 >                # Isotropic BSDF
217 >                my $ns2 = $ns / 2;
218 >                $cmd = "cnt $ns2 $ny $nx " .
219 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
220 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
221 >                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
222 >                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
223 >                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
224 >                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
225 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
226 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
227 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
228 >                        "| $cmd";
229 >        } else {
230 >                # Anisotropic BSDF
231 >                # Sample area vertically to improve load balance, since
232 >                # shading systems usually have bilateral symmetry (L-R)
233 >                $cmd = "cnt $ns $ns $ny $nx " .
234 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
235 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
236 >                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
237 >                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
238 >                        "-e 'in_square_x=(\$1+r1)/$ns' " .
239 >                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
240 >                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
241 >                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
242 >                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
243 >                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
244 >                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
245 >                        "| $cmd";
246 >        }
247 > # print STDERR "Starting: $cmd\n";
248 >        system "$cmd" || die "Failure running rcontrib";
249 >        ttree_out($forw);
250 > }       # end of do_tree_rtcontrib()
251 >
252 > # Simplify and output tensor tree results
253 > sub ttree_out {
254 >        my $forw = shift;
255 >        my $side = ("Back","Front")[$forw];
256 >        my $cmd;
257 > # Only output one transmitted distribution, preferring backwards
258 > if ( !$forw || !$doback ) {
259 > print
260 > '       <WavelengthData>
261 >                <LayerNumber>System</LayerNumber>
262 >                <Wavelength unit="Integral">Visible</Wavelength>
263 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
264 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
265 >                <WavelengthDataBlock>
266 >                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
267 >                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
268 >                        <ScatteringDataType>BTDF</ScatteringDataType>
269 >                        <ScatteringData>
270 > ';
271 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
272 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
273 > if ($pctcull >= 0) {
274 >        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
275 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
276 >        system "$cmd" || die "Failure running rttree_reduce";
277 > } else {
278 >        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
279 >        print "{\n";
280 >        system "$cmd" || die "Failure running rcalc";
281 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
282 >                print "0\n";
283 >        }
284 >        print "}\n";
285 > }
286 > print
287 > '                       </ScatteringData>
288 >                </WavelengthDataBlock>
289 >        </WavelengthData>
290 > ';
291 > }
292 > # Output reflection
293 > print
294 > '       <WavelengthData>
295 >                <LayerNumber>System</LayerNumber>
296 >                <Wavelength unit="Integral">Visible</Wavelength>
297 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
298 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
299 >                <WavelengthDataBlock>
300 > ';
301 > print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
302 > print
303 > '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
304 >                        <ScatteringDataType>BRDF</ScatteringDataType>
305 >                        <ScatteringData>
306 > ';
307 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
308 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
309 > if ($pctcull >= 0) {
310 >        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
311 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
312 >        system "$cmd" || die "Failure running rttree_reduce";
313 > } else {
314 >        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
315 >        print "{\n";
316 >        system "$cmd" || die "Failure running rcalc";
317 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
318 >                print "0\n";
319 >        }
320 >        print "}\n";
321 > }
322 > print
323 > '                       </ScatteringData>
324 >                </WavelengthDataBlock>
325 >        </WavelengthData>
326 > ';
327 > }       # end of ttree_out()
328 >
329 > #------------- End of do_tree_bsdf() & subroutines -------------#
330 >
331 > #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
332 > sub do_matrix_bsdf {
333 > # Set up sampling of portal
334   # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
335 < my $tcal = '
335 > $tcal = '
336   DEGREE : PI/180;
337   sq(x) : x*x;
338 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
338 > Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
339   Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
340   Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
341   Kmax : Kaccum(Knaz(0));
# Line 85 | Line 345 | Kcol = Kbin - Kaccum(Krow-1);
345   Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
346   Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
347   sin_kpol = sin(Kpol);
348 < Dx = -cos(Kazi)*sin_kpol;
348 > Dx = cos(Kazi)*sin_kpol;
349   Dy = sin(Kazi)*sin_kpol;
350   Dz = sqrt(1 - sin_kpol*sin_kpol);
351   KprojOmega = PI * if(Kbin-.5,
352          (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
353          1 - sq(cos(Kpola(1)*DEGREE)));
354   ';
355 < # Compute Klems bin from exiting ray direction
356 < my $kcal = '
355 > # Compute Klems bin from exiting ray direction (forward or backward)
356 > $kcal = '
357   DEGREE : PI/180;
358 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
358 > abs(x) : if(x, x, -x);
359 > Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
360   posangle(a) : if(-a, a + 2*PI, a);
361 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
361 > Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
362   kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
363   knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
364   kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
# Line 115 | Line 376 | kbin2(pol,azi) = select(kfindrow(1, pol),
376                  kaccum(7) + kazn(azi,360/knaz(8)),
377                  kaccum(8) + kazn(azi,360/knaz(9))
378          );
379 < kbin = kbin2(Acos(Dz), Atan2(Dy, -Dx));
379 > kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
380   ';
381   my $ndiv = 145;
382 < my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
383 < my $ny = int($nsamp/$nx + .5);
384 < $nsamp = $nx * $ny;
385 < # Compute scattering data using rtcontrib
386 < my $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
382 > # Compute scattering data using rcontrib
383 > my @tfarr;
384 > my @rfarr;
385 > my @tbarr;
386 > my @rbarr;
387 > my $cmd;
388 > my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
389 >        "-e '$kcal' -b kbin -bn $ndiv " .
390 >        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
391 > my $rccmd = "rcalc -e '$tcal' " .
392 >        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
393 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
394 > if ( $doforw ) {
395 > $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
396 >        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
397 >        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
398 >        "-e 'zp:$dim[4]' " .
399 >        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
400 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
401 >        "| $rtcmd";
402 > system "$cmd" || die "Failure running: $cmd\n";
403 > @tfarr = `$rccmd $td/$fmodnm.flt`;
404 > die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
405 > @rfarr = `$rccmd $td/$bmodnm.flt`;
406 > die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
407 > }
408 > if ( $doback ) {
409 > $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
410          "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
411          "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
412 <        "-e 'zp:$dim[4]-1e-5' " .
412 >        "-e 'zp:$dim[5]' " .
413          q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
414 <        q{-e '$1=xp;$2=yp;$3=zp;$4=Dx;$5=Dy;$6=Dz' } .
415 <        "| rtcontrib -h -ff -n $nproc -c $nsamp -e '$kcal' -b kbin -bn $ndiv " .
416 <        "-m $modnm -w -ab 5 -ad 700 -lw 3e-6 $octree " .
417 <        "| rcalc -e '$tcal' " .
418 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
419 <        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
420 < my @darr = `$cmd`;
421 < die "Failure running: $cmd\n" if ( $? );
422 < # Output XML prologue
139 < print
140 < '<?xml version="1.0" encoding="UTF-8"?>
141 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
142 <        <WindowElementType>System</WindowElementType>
143 <        <Optical>
144 <                <Layer>
145 <                <Material>
146 <                        <Name>Name</Name>
147 <                        <Manufacturer>Manufacturer</Manufacturer>
148 < ';
149 < printf "\t\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
150 < printf "\t\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
151 < printf "\t\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
152 < print "\t\t\t<DeviceType>Integral</DeviceType>\n";
153 < # Output MGF description if requested
154 < if ( $geout ) {
155 <        print "\t\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
156 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
157 <        system "cat $mgfscn";
158 <        print "xf\n";
159 <        print "\t\t\t</Geometry>\n";
414 >        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
415 >        "| $rtcmd";
416 > system "$cmd" || die "Failure running: $cmd\n";
417 > @tbarr = `$rccmd $td/$bmodnm.flt`;
418 > die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
419 > chomp(@tbarr);
420 > @rbarr = `$rccmd $td/$fmodnm.flt`;
421 > die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
422 > chomp(@rbarr);
423   }
424 < print '                 </Material>
425 <                <DataDefinition>
426 <                        <IncidentDataStructure>Columns</IncidentDataStructure>
427 <                        <AngleBasis>
424 > # Output angle basis
425 > print
426 > '       <DataDefinition>
427 >                <IncidentDataStructure>Columns</IncidentDataStructure>
428 >                <AngleBasis>
429                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
430 <                                <AngleBasisBlock>
431 <                                <Theta>0</Theta>
432 <                                <nPhis>1</nPhis>
433 <                                <ThetaBounds>
430 >                        <AngleBasisBlock>
431 >                        <Theta>0</Theta>
432 >                        <nPhis>1</nPhis>
433 >                        <ThetaBounds>
434                                  <LowerTheta>0</LowerTheta>
435                                  <UpperTheta>5</UpperTheta>
436 <                                </ThetaBounds>
173 <                                </AngleBasisBlock>
174 <                                <AngleBasisBlock>
175 <                                <Theta>10</Theta>
176 <                                <nPhis>8</nPhis>
177 <                                <ThetaBounds>
178 <                                        <LowerTheta>5</LowerTheta>
179 <                                        <UpperTheta>15</UpperTheta>
180 <                                </ThetaBounds>
181 <                                </AngleBasisBlock>
182 <                                <AngleBasisBlock>
183 <                                <Theta>20</Theta>
184 <                                <nPhis>16</nPhis>
185 <                                <ThetaBounds>
186 <                                        <LowerTheta>15</LowerTheta>
187 <                                        <UpperTheta>25</UpperTheta>
188 <                                </ThetaBounds>
189 <                                </AngleBasisBlock>
190 <                                <AngleBasisBlock>
191 <                                <Theta>30</Theta>
192 <                                <nPhis>20</nPhis>
193 <                                <ThetaBounds>
194 <                                        <LowerTheta>25</LowerTheta>
195 <                                        <UpperTheta>35</UpperTheta>
196 <                                </ThetaBounds>
197 <                                </AngleBasisBlock>
198 <                                <AngleBasisBlock>
199 <                                <Theta>40</Theta>
200 <                                <nPhis>24</nPhis>
201 <                                <ThetaBounds>
202 <                                        <LowerTheta>35</LowerTheta>
203 <                                        <UpperTheta>45</UpperTheta>
204 <                                </ThetaBounds>
205 <                                </AngleBasisBlock>
206 <                                <AngleBasisBlock>
207 <                                <Theta>50</Theta>
208 <                                <nPhis>24</nPhis>
209 <                                <ThetaBounds>
210 <                                        <LowerTheta>45</LowerTheta>
211 <                                        <UpperTheta>55</UpperTheta>
212 <                                </ThetaBounds>
213 <                                </AngleBasisBlock>
214 <                                <AngleBasisBlock>
215 <                                <Theta>60</Theta>
216 <                                <nPhis>24</nPhis>
217 <                                <ThetaBounds>
218 <                                        <LowerTheta>55</LowerTheta>
219 <                                        <UpperTheta>65</UpperTheta>
220 <                                </ThetaBounds>
221 <                                </AngleBasisBlock>
222 <                                <AngleBasisBlock>
223 <                                <Theta>70</Theta>
224 <                                <nPhis>16</nPhis>
225 <                                <ThetaBounds>
226 <                                        <LowerTheta>65</LowerTheta>
227 <                                        <UpperTheta>75</UpperTheta>
228 <                                </ThetaBounds>
229 <                                </AngleBasisBlock>
230 <                                <AngleBasisBlock>
231 <                                <Theta>82.5</Theta>
232 <                                <nPhis>12</nPhis>
233 <                                <ThetaBounds>
234 <                                        <LowerTheta>75</LowerTheta>
235 <                                        <UpperTheta>90</UpperTheta>
236 <                                </ThetaBounds>
436 >                        </ThetaBounds>
437                          </AngleBasisBlock>
438 +                        <AngleBasisBlock>
439 +                        <Theta>10</Theta>
440 +                        <nPhis>8</nPhis>
441 +                        <ThetaBounds>
442 +                                <LowerTheta>5</LowerTheta>
443 +                                <UpperTheta>15</UpperTheta>
444 +                        </ThetaBounds>
445 +                        </AngleBasisBlock>
446 +                        <AngleBasisBlock>
447 +                        <Theta>20</Theta>
448 +                        <nPhis>16</nPhis>
449 +                        <ThetaBounds>
450 +                                <LowerTheta>15</LowerTheta>
451 +                                <UpperTheta>25</UpperTheta>
452 +                        </ThetaBounds>
453 +                        </AngleBasisBlock>
454 +                        <AngleBasisBlock>
455 +                        <Theta>30</Theta>
456 +                        <nPhis>20</nPhis>
457 +                        <ThetaBounds>
458 +                                <LowerTheta>25</LowerTheta>
459 +                                <UpperTheta>35</UpperTheta>
460 +                        </ThetaBounds>
461 +                        </AngleBasisBlock>
462 +                        <AngleBasisBlock>
463 +                        <Theta>40</Theta>
464 +                        <nPhis>24</nPhis>
465 +                        <ThetaBounds>
466 +                                <LowerTheta>35</LowerTheta>
467 +                                <UpperTheta>45</UpperTheta>
468 +                        </ThetaBounds>
469 +                        </AngleBasisBlock>
470 +                        <AngleBasisBlock>
471 +                        <Theta>50</Theta>
472 +                        <nPhis>24</nPhis>
473 +                        <ThetaBounds>
474 +                                <LowerTheta>45</LowerTheta>
475 +                                <UpperTheta>55</UpperTheta>
476 +                        </ThetaBounds>
477 +                        </AngleBasisBlock>
478 +                        <AngleBasisBlock>
479 +                        <Theta>60</Theta>
480 +                        <nPhis>24</nPhis>
481 +                        <ThetaBounds>
482 +                                <LowerTheta>55</LowerTheta>
483 +                                <UpperTheta>65</UpperTheta>
484 +                        </ThetaBounds>
485 +                        </AngleBasisBlock>
486 +                        <AngleBasisBlock>
487 +                        <Theta>70</Theta>
488 +                        <nPhis>16</nPhis>
489 +                        <ThetaBounds>
490 +                                <LowerTheta>65</LowerTheta>
491 +                                <UpperTheta>75</UpperTheta>
492 +                        </ThetaBounds>
493 +                        </AngleBasisBlock>
494 +                        <AngleBasisBlock>
495 +                        <Theta>82.5</Theta>
496 +                        <nPhis>12</nPhis>
497 +                        <ThetaBounds>
498 +                                <LowerTheta>75</LowerTheta>
499 +                                <UpperTheta>90</UpperTheta>
500 +                        </ThetaBounds>
501 +                        </AngleBasisBlock>
502                  </AngleBasis>
503          </DataDefinition>
504 <        <WavelengthData>
504 > ';
505 > if ( $doforw ) {
506 > print
507 > '       <WavelengthData>
508                  <LayerNumber>System</LayerNumber>
509                  <Wavelength unit="Integral">Visible</Wavelength>
510                  <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
# Line 249 | Line 516 | print '                        </Material>
516                          <ScatteringDataType>BTDF</ScatteringDataType>
517                          <ScatteringData>
518   ';
519 < # Output computed data (transposed order)
519 > # Output front transmission (transposed order)
520   for (my $od = 0; $od < $ndiv; $od++) {
521          for (my $id = 0; $id < $ndiv; $id++) {
522 <                print $darr[$ndiv*$id + $od];
522 >                print $tfarr[$ndiv*$id + $od], ",\n";
523          }
524          print "\n";
525   }
259 # Output XML epilogue
526   print
527 < '               </ScatteringData>
528 <        </WavelengthDataBlock>
527 > '                       </ScatteringData>
528 >                </WavelengthDataBlock>
529          </WavelengthData>
530 < </Layer>
531 < </Optical>
532 < </WindowElement>
530 >        <WavelengthData>
531 >                <LayerNumber>System</LayerNumber>
532 >                <Wavelength unit="Integral">Visible</Wavelength>
533 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
534 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
535 >                <WavelengthDataBlock>
536 >                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
537 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
538 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
539 >                        <ScatteringDataType>BRDF</ScatteringDataType>
540 >                        <ScatteringData>
541   ';
542 < # Clean up temporary files
543 < system "rm -rf $td";
542 > # Output front reflection (transposed order)
543 > for (my $od = 0; $od < $ndiv; $od++) {
544 >        for (my $id = 0; $id < $ndiv; $id++) {
545 >                print $rfarr[$ndiv*$id + $od], ",\n";
546 >        }
547 >        print "\n";
548 > }
549 > print
550 > '                       </ScatteringData>
551 >                </WavelengthDataBlock>
552 >        </WavelengthData>
553 > ';
554 > }
555 > if ( $doback ) {
556 > print
557 > '       <WavelengthData>
558 >                <LayerNumber>System</LayerNumber>
559 >                <Wavelength unit="Integral">Visible</Wavelength>
560 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
561 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
562 >                <WavelengthDataBlock>
563 >                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
564 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
565 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
566 >                        <ScatteringDataType>BTDF</ScatteringDataType>
567 >                        <ScatteringData>
568 > ';
569 > # Output back transmission (transposed order)
570 > for (my $od = 0; $od < $ndiv; $od++) {
571 >        for (my $id = 0; $id < $ndiv; $id++) {
572 >                print $tbarr[$ndiv*$id + $od], ",\n";
573 >        }
574 >        print "\n";
575 > }
576 > print
577 > '                       </ScatteringData>
578 >                </WavelengthDataBlock>
579 >        </WavelengthData>
580 >        <WavelengthData>
581 >                <LayerNumber>System</LayerNumber>
582 >                <Wavelength unit="Integral">Visible</Wavelength>
583 >                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
584 >                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
585 >                <WavelengthDataBlock>
586 >                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
587 >                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
588 >                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
589 >                        <ScatteringDataType>BRDF</ScatteringDataType>
590 >                        <ScatteringData>
591 > ';
592 > # Output back reflection (transposed order)
593 > for (my $od = 0; $od < $ndiv; $od++) {
594 >        for (my $id = 0; $id < $ndiv; $id++) {
595 >                print $rbarr[$ndiv*$id + $od], ",\n";
596 >        }
597 >        print "\n";
598 > }
599 > print
600 > '                       </ScatteringData>
601 >                </WavelengthDataBlock>
602 >        </WavelengthData>
603 > ';
604 > }
605 > }
606 > #------------- End of do_matrix_bsdf() --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines